REM
REM  Adjust emulation timing
REM  Part of the ZilogBoy project
REM  Copyright (C) Mateusz Viste 2010
REM

DIM SHARED AS ULONGINT TotalCycles ' ULONGINT is 64bit. Can go up to 18446744073709551615 (@4MHz = 139461 years)
DIM SHARED AS ULONGINT DropCycles, NextTimingCheck
DIM SHARED AS DOUBLE EmulationStartTimer

SUB AdjustTiming(BYREF addcycles AS UBYTE)
  REM  Note: GameBoy speed is 4194304 CPU cycles/s
  TotalCycles += addcycles
  IF TotalCycles > NextTimingCheck THEN
    NextTimingCheck += 40000      ' Don't check timing more often than every 10 milliseconds
    WHILE (TIMER - EmulationStartTimer) < (TotalCycles / 4194304) ' Loop until timing is right
      IF TIMER < EmulationStartTimer THEN  ' Just in case the TIMER counter would wrap...
        EmulationStartTimer = TIMER
        TotalCycles = 0
      END IF
      DropCycles += 1
    WEND
  END IF
END SUB
